﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ASPItalia.Books.Chapter05
{
    public class Utils
    {
        public static void Swap<T>(ref T first, ref T second)
        {
            T temp = first;
            first = second;
            second = temp;
        }

        public static T Max<T>(IEnumerable<T> list) where T : IComparable
        {
            bool isFirst = true;

            T res = default(T);
            foreach (T item in list)
            {
                if (isFirst)
                {
                    res = item;
                    isFirst = false;
                }

                if (res.CompareTo(item) < 0)
                    res = item;
            }

            return res;
        }

    }
}
