﻿using System.Xml;
using System.IO;
using System;

public class Sample3
{
    public static void Run()
    {
        XmlDocument doc = new XmlDocument();

        // Uri: percorso relativo al file
        doc.Load("test.xml");

        // Nome del tag e namespace dell'ultimo figlio
        Console.WriteLine("LocalName: {0} - Namespace: {1}",
          doc.DocumentElement.LastChild.LocalName,
          doc.DocumentElement.LastChild.NamespaceURI);

        // Attributo idProduct sull'ultimo figlio (tag product)
        XmlElement product = (XmlElement)doc.DocumentElement.LastChild;
        Console.WriteLine("idProduct: {0}",
          product.Attributes["idProduct"].Value);
        Console.WriteLine("idProduct: {0}",
          product.GetAttribute("idProduct"));

        // XML del primo figlio di products (il commento)
        Console.WriteLine("Comment: {0}",
          doc.DocumentElement.FirstChild.OuterXml);

        // Tag description del secondo figlio (tag product)
        XmlElement description =
          doc.DocumentElement.ChildNodes[1]["description",
          "http://schemas.aspitalia.com/book40/products"];

        // InnerText interroga direttamente il value dei figli
        Console.WriteLine("Description: {0}", description.InnerText);
        // Entro direttamente nel figlio che è un XmlText
        Console.WriteLine("Description: {0}", description.FirstChild.Value);

    }

}