﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Printing;
using System.Windows.Xps;
using System.Windows.Xps.Packaging;
using System.IO;

namespace ASPItalia.Books.Chapter13
{
    /// <summary>
    /// Interaction logic for Print.xaml
    /// </summary>
    public partial class Print : Window
    {
        public Print()
        {
            InitializeComponent();
        }

        private void Print_Click(System.Object sender, System.Windows.RoutedEventArgs e)
        {

            // Ottengo la stampante predefinita locale
            using (PrintQueue queue = LocalPrintServer.GetDefaultPrintQueue())
            {

                // Ottengo il writer sulla stampante
                XpsDocumentWriter writer = PrintQueue.CreateXpsDocumentWriter(queue);

                IDocumentPaginatorSource source = (IDocumentPaginatorSource)this.document;

                writer.Write(source.DocumentPaginator);
            }
        }

        private void SaveXPS_Click(System.Object sender, System.Windows.RoutedEventArgs e)
        {
            // Creo il file
            using (XpsDocument doc = new XpsDocument("test.xps", FileAccess.ReadWrite))
            {

                XpsDocumentWriter writer = XpsDocument.CreateXpsDocumentWriter(doc);

                // Scrivo il FlowDocument
                IDocumentPaginatorSource source = (IDocumentPaginatorSource)this.document;

                writer.Write(source.DocumentPaginator);
            }
        }

    }
}
