﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Security.Cryptography;
using System.IO;
using System.Text;

namespace Cryptography
{
  public partial class MainWindow : Window
  {
    TripleDESCryptoServiceProvider cryptoProvider;
    byte[] key;
    byte[] vector;
    string data = "testo da cifrare";

    public MainWindow()
    {
      InitializeComponent();

      cryptoProvider = new TripleDESCryptoServiceProvider();

      //TripleDESCryptoServiceProvider cryptoProvider = new TripleDESCryptoServiceProvider();
      key = cryptoProvider.Key;
      vector = cryptoProvider.IV;

      this.key = new byte[] { 0xea, 12, 0x43, 0xf5, 0x42, 0x63, 0x16, 0xd6, 6, 0x58, 0x7c, 0x2c, 0xdd, 0x22, 9, 0x16 };

      string password = "password per generare chiave";
      string salt = "salt per generare chiave";

      byte[] passwordByte = Encoding.UTF8.GetBytes(password);
      byte[] saltByte = Encoding.UTF8.GetBytes(salt);

      this.key = new PasswordDeriveBytes(passwordByte, saltByte).CryptDeriveKey("TripleDES", "SHA1", 192, this.vector);
    }

    private void Button_Click(object sender, RoutedEventArgs e)
    {
      byte[] dataByte = Encoding.UTF8.GetBytes(this.data);
      byte[] entropy = Encoding.UTF8.GetBytes("chiave ulteriore sicurezza");
      byte[] dataCripted = ProtectedData.Protect(dataByte, entropy, DataProtectionScope.CurrentUser);
      this.tb1.Text = Encoding.UTF8.GetString(dataCripted);
    }

    private void Button1_Click(object sender, RoutedEventArgs e)
    {
      byte[] dataByte = Encoding.UTF8.GetBytes(this.data);
      using (ICryptoTransform encryptor = this.cryptoProvider.CreateEncryptor(this.key, this.vector))
      {
        using (Stream stream = File.Create(@"d:\encrypted.txt"))
        {
          using (CryptoStream cryptoStream = new CryptoStream(stream, encryptor, CryptoStreamMode.Write))
          {
            cryptoStream.Write(dataByte, 0, dataByte.Length);
            cryptoStream.FlushFinalBlock();
          }
        }
      }
    }

    private void Button2_Click(object sender, RoutedEventArgs e)
    {
      using (ICryptoTransform encryptor = this.cryptoProvider.CreateDecryptor(this.key, this.vector))
      {
        using (Stream stream = File.OpenRead(@"d:\encrypted.txt"))
        {
          using (Stream cryptoStream = new CryptoStream(stream, encryptor, CryptoStreamMode.Read))
          {
            using (StreamReader reader = new StreamReader(cryptoStream))
            {
              this.tb2.Text = reader.ReadToEnd();
            }
          }
        }
      }
    }

    private void Button3_Click(object sender, RoutedEventArgs e)
    {
      using (RSACryptoServiceProvider asCryptoProvider = new RSACryptoServiceProvider())
      {
        File.WriteAllText(@"d:\PublicKey.xml", asCryptoProvider.ToXmlString(false));
        File.WriteAllText(@"d:\PublicAndPrivate.xml", asCryptoProvider.ToXmlString(true));
      }
    }

    //chiavi di cifratura simmetrica criptate con RSA, da passare al destinatario
    private byte[] keyCrypted;
    private byte[] vectorCrypted;

    private void Button4_Click(object sender, RoutedEventArgs e)
    {
      //creazione chiave simmetrica per cifratura
      TripleDESCryptoServiceProvider cryptoProvider = new TripleDESCryptoServiceProvider();
      byte[] key = cryptoProvider.Key;
      byte[] vector = cryptoProvider.IV;

      //lettura chiave pubblica per cifratura asimmetrica
      string publicKeyOnly = File.ReadAllText(@"d:\PublicKey.xml");

      //cifratura asimmetrica della chiave simmetrica
      using (RSACryptoServiceProvider asCryptoProvider = new RSACryptoServiceProvider())
      {
        asCryptoProvider.FromXmlString(publicKeyOnly);
        this.keyCrypted = asCryptoProvider.Encrypt(key, true);
        this.vectorCrypted = asCryptoProvider.Encrypt(vector, true);
      }

      //dati riservati
      byte[] dataByte = Encoding.UTF8.GetBytes(this.data);

      //cifratura simmetrica con chiave e vettore autogenerati
      using (ICryptoTransform encryptor = cryptoProvider.CreateEncryptor(key, vector))
      {
        using (Stream stream = File.Create(@"d:\encrypted.txt"))
        {
          using (CryptoStream cryptoStream = new CryptoStream(stream, encryptor, CryptoStreamMode.Write))
          {
            cryptoStream.Write(dataByte, 0, dataByte.Length);
            cryptoStream.FlushFinalBlock();
          }
        }
      }
    }

    private void Button5_Click(object sender, RoutedEventArgs e)
    {
      byte[] keyDecrypted;
      byte[] vectorDecrypted;

      //lettura chiave pubblica e privata
      string publicPrivate = File.ReadAllText(@"d:\PublicAndPrivate.xml");

      //decifratura chiave simmetrica e vettore, con algoritmo asimmetrico
      using (RSACryptoServiceProvider asCryptoProvider = new RSACryptoServiceProvider())
      {
        asCryptoProvider.FromXmlString(publicPrivate);
        keyDecrypted = asCryptoProvider.Decrypt(this.keyCrypted, true);
        vectorDecrypted = asCryptoProvider.Decrypt(this.vectorCrypted, true);
      }

      //decifratura dati riservati con chiave simmetrica decifrata
      using (ICryptoTransform encryptor = this.cryptoProvider.CreateDecryptor(keyDecrypted, vectorDecrypted))
      {
        using (Stream stream = File.OpenRead(@"d:\encrypted.txt"))
        {
          using (Stream cryptoStream = new CryptoStream(stream, encryptor, CryptoStreamMode.Read))
          {
            using (StreamReader reader = new StreamReader(cryptoStream))
            {
              this.tb3.Text = reader.ReadToEnd();
            }
          }
        }
      }
    }

    private void Button6_Click(object sender, RoutedEventArgs e)
    {
      this.main.Visibility = Visibility.Collapsed;

      byte[] data = Encoding.UTF8.GetBytes(this.tb4.Text);

      byte[] hash1 = MD5.Create().ComputeHash(data);
      byte[] hash2 = SHA1.Create().ComputeHash(data);
      byte[] hash3 = SHA512.Create().ComputeHash(data);

      this.tb5.Text = this.GetHexadecimal(hash1);
      this.tb6.Text = this.GetHexadecimal(hash2);
      this.tb7.Text = this.GetHexadecimal(hash3);
    }

    public string GetHexadecimal(byte[] hash)
    {
      StringBuilder sBuilder = new StringBuilder();

      int i = 0;
      for (i = 0; i <= hash.Length - 1; i++)
      {
        sBuilder.Append(hash[i].ToString("x2"));
      }
      return sBuilder.ToString();
    }

    public void Test()
    {
      //string query = string.Format("SELECT * FROM Users WHERE Username='{0}' AND Password='{1}'", tbxUsername.Text, tbxPassword.Text);

      //SqlConnection connection = new SqlConnection("stringa di connessione");
      //string query = "SELECT * FROM Users WHERE Username = @Username";
      //SqlCommand command = new SqlCommand(query, connection);
      //SqlParameter param = new SqlParameter("@Username", SqlDbType.NVarChar, 100);
      //param.Value = tbxUsername.Text;
      //command.Parameters.Add(param);
      //SqlDataReader reader = command.ExecuteReader();
    }
























  }
}
