﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security;
using System.IO;
using System.Security.Permissions;

[assembly: AllowPartiallyTrustedCallers]
namespace Plugin
{
  public class PluginElement : MarshalByRefObject
  {
    [SecurityCritical]
    public void DirectWriteFile(string data, string path)
    {
      Stream dataStream = File.OpenWrite(path);
      StreamWriter str = new StreamWriter(dataStream);
      str.Write(data);
      str.Close();
      dataStream.Close();
    }

    [SecuritySafeCritical]
    public void WriteFile(string data, string path)
    {
      new FileIOPermission(FileIOPermissionAccess.Write, new string[] { path }).Demand();
      this.DirectWriteFile(data, path);
    }
  }
}
