﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CopyDirectory
{
  class Program
  {
    static void Main(string[] args)
    {
      DirectoryInfo[] directories = new DirectoryInfo(
        Environment.GetFolderPath(
        Environment.SpecialFolder.CommonDocuments)).GetDirectories();
      try
      {
        foreach (DirectoryInfo directoryInfo in directories)
        {
          if (!directoryInfo.GetAccessControl().AreAccessRulesProtected)
          {
            string copyPath = Path.Combine(
              Environment.GetFolderPath(
              Environment.SpecialFolder.CommonDocuments),
              string.Format("{0} copia", directoryInfo.Name));
            Directory.CreateDirectory(copyPath);
            Console.WriteLine(string.Format("Cartella {0} copiata correttamente", 
              directoryInfo.Name));
            FileInfo[] files = directoryInfo.GetFiles();
            foreach (FileInfo fileInfo in files)
            {
              fileInfo.CopyTo(Path.Combine(
                copyPath, string.Format("{0} copia{1} ",
                Path.GetFileNameWithoutExtension(fileInfo.Name),
                Path.GetExtension(fileInfo.Name))));
              Console.WriteLine(string.Format("File {0} copiato correttamente", 
                fileInfo.Name));
            }
          }
          else
          {
            Console.WriteLine(string.Format("Impossibile copiare la cartella {0}", 
              directoryInfo.Name));
          }
        }
      }
      catch (Exception ex)
      {
        Console.WriteLine("Si è verificato un errore: {0}", ex.ToString());
      }
      Console.ReadLine();
    }
  }
}
