﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.IsolatedStorage;
using System.IO;

namespace IsolatedStorage
{
  class Program
  {
    static void Main(string[] args)
    {
      try
      {
        IsolatedStorageFile isoFile = IsolatedStorageFile.GetStore(
          IsolatedStorageScope.User | IsolatedStorageScope.Assembly | IsolatedStorageScope.Domain, 
          typeof(System.Security.Policy.Url), typeof(System.Security.Policy.Url));
        if (!isoFile.DirectoryExists("Documenti"))
        {
          isoFile.CreateDirectory("Documenti");
        }
        IsolatedStorageFileStream isoStream = isoFile.CreateFile("myFile.txt");
        byte[] info = new UTF8Encoding(true).GetBytes("Un saluto dall'autore di questo capitolo.");
        isoStream.Write(info, 0, info.Length);
        isoStream.Close();
        StreamReader mySteamiReader = new StreamReader(
          isoFile.OpenFile("myFile.txt", FileMode.Open));
        while (mySteamiReader.Peek() >= 0)
        {
          Console.WriteLine("il file contiene: {0}", mySteamiReader.ReadLine());
        }
        mySteamiReader.Close();
      }
      catch (Exception ex)
      {
        Console.WriteLine("Si è verificato un errore: {0}", ex.ToString());
      }
      Console.ReadLine();

    }
  }
}
